<template>
  <div class="p-5 h-full">
    <div class="grid grid-cols-3">
      <div></div>
      <div class="text-center text-4xl">Se connecter</div>
    </div>
    <div class="flex flex-row justify-center">
      <v-form
        :value="valid"
        ref="form"
        @submit.prevent="signInWithEmailAndPassword"
      >
        <div
          class="flex flex-col border border-gray-100 rounded-xl p-5 mt-20 gap-5"
        >
          <v-text-field
            label="E-mail"
            id="email"
            type="email"
            :rules="emailRules"
            :error-messages="errMessage"
            v-model="user.email"
            autocomplete="email"
          />
          <v-text-field
            label="Mot de passe"
            id="password"
            v-model="user.password"
            :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
            :type="show ? 'text' : 'password'"
            :error-messages="passErrMessage"
            @click:append="show = !show"
            :rules="passwordRules"
            autocomplete="current-password"
          />
          <v-btn
            text
            color="primary"
            type="submit"
            :loading="loading"
            :disabled="loading"
            >Connexion</v-btn
          >
          <v-btn text color="primary" @click="goToSignIn">S'inscrire</v-btn>
        </div>
      </v-form>
    </div>
  </div>
</template>

<script>
export default {
  methods: {
    goToSignIn() {
      this.$router.push("signup");
    },
    signInWithEmailAndPassword() {
      if (this.$refs.form.validate()) {
        this.loading = true;
        this.$store
          .dispatch("login", this.user, this.errMessage)
          .catch((err) => {
            if (err.code == "auth/wrong-password") {
              this.$refs.form.reset();
              this.passErrMessage = "Le mot de passe  est incorrect.";

            } else if (err.code == "auth/user-not-found") {
              this.$refs.form.reset();
              this.errMessage = "Utilisateur introuvable.";
            } 
            
            else console.log(err);
            this.loading = false;
          });
      }
    },
  },
  data() {
    return {
      show: false,
      passwordRules: [(v) => !!v || "Le mot de passe est requis"],
      emailRules: [
        (v) => !!v || "Le mail est requis",
        (v) =>
          /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) ||
          "Le mail n'est pas valide",
      ],
      valid: false,
      errMessage: "",
      passErrMessage: "",
      loading: false,
      user: Object,
    };
  },
};
</script>

<style>
</style>